
;;;;-----------------------------------Hauptprogramm---------------------------------------------------------

(defun C:Attdreh (/            MDIALOG      OK           hoe
                  atthoe       md_neu_atthoe             brei
                  md_neu_attbrei            attbrei      wink
                  md_neu_attwink   md_neu_attneig         attwink attneig neig
                  )

  (setq md_err  *error*
        *error* Fehler
        ) ;_ end of setq
  (command "_UNDO" "_MARK")

  (md_setvar)
;;;Systemvariablen stellen

  (setq MDIALOG (load_dialog "ATTHOE.DCL"))
  (if (not (new_dialog "atthoe" MDIALOG))
    (progn
      (alert
        "Dialogsteuerungsdatei Atthoe.DCL nicht gefunden. \nAbbruch!"
        ) ;_ end of alert
      (exit)
      )                                 ;ende Progn
    ) ;_ end of if
  (action_tile "hoe" "(setq hoe (atoi $value))")
  (action_tile "atthoe" "(setq atthoe  $value)")
  (action_tile "brei" "(setq brei (atoi $value))")
  (action_tile "attbrei" "(setq attbrei (atof $value))")
  (action_tile "wink" "(setq wink (atoi $value))")
  (action_tile
    "attwink"
    "(setq attwink(f:str-change1 $value \",\" \".\"))"
    ) ;_ end of action_tile
  (action_tile "neig" "(setq neig (atoi $value))")
  (action_tile
    "attneig"
    "(setq attneig(f:str-change1 $value \",\" \".\"))"
    )
  (action_tile "cancel" "(done_dialog 0)")
  (action_tile "accept" "(done_dialog 1)")
  (setq OK (start_dialog))
  (unload_dialog MDIALOG)
;;;Aufruf der Prfprogramme
  (if OK
    (progn
      (if (and (= 1 hoe) (/= atthoe nil))
        (setq md_neu_atthoe (atof atthoe))
        ) ;_ end of if
      (if (and (= 1 brei) (/= attbrei nil))
        (setq md_neu_attbrei (float attbrei))
        ) ;_ end of if
      (if (and (= 1 wink) (/= attwink nil))
        (setq md_neu_attwink attwink)
        ) ;_ end of if
      (if (and (= 1 neig) (/= attneig nil))
        (setq md_neu_attneig attneig)
        )
      (if
        (or (/= md_neu_atthoe nil)
            (/= md_neu_attbrei nil)
            (/= md_neu_attwink nil)
            (/= md_neu_attneig nil)
            ) ;_ end of or
         (md_attdreh md_neu_atthoe md_neu_attbrei md_neu_attwink md_neu_attneig)
         ) ;_ end of if
      ) ;_ end of progn
    ) ;_ end of if

  ;;Unterprogramm zur umsetzung der Trattribute

  (princ "\nFertig")
  (princ)

  )                                     ;ende defun


                                        ;---------------------------Systemvariablen setzen-------------------------------------
(defun md_setvar (/)
  (setq md_cmddia    (getvar "cmddia")
        md_cmdecho   (getvar "cmdecho")
        md_filedia   (getvar "filedia")
        md_osmode    (getvar "osmode")
        md_orthomode (getvar "orthomode")
        md_attreq    (getvar "attreq")
        ) ;_ end of setq
  (setvar "cmdecho" 0)
                                        ;(setvar "cmddia" 0)
                                        ;(setvar "filedia" 0)
  (setvar "osmode" 0)
  (setvar "orthomode" 0)
  (setvar "attreq" 0)
  )                                     ;ende defun

                                        ;----------------------------Variablen zurckstellen-------------------------------
(defun md_reset (/)
  (setvar "cmdecho" md_cmdecho)
                                        ;(setvar "cmddia" md_cmddia)
                                        ;(setvar "filedia" md_filedia)
  (setvar "osmode" md_osmode)
  (setvar "orthomode" md_orthomode)
  (setvar "attreq" md_attreq)
  )                                     ;ende defun

                                        ;----------------------------Fehlerbehandlung--------------------------------------
(defun Fehler (s)
  (print (strcat "Fehler " s))
  (command)
  (command "_UNDO" "_BACK")
  (setq *error* md_err)
  (princ)
  ) ;_ end of defun

                                        ;-------------------------Filterliste erstellen
(defun md_filterliste (/ as_filter md_fl elem)

  (prompt
    "\nBlock whlen, dessen Attribute gendert werden sollen."
    ) ;_ end of prompt
  (if(setq elem (entsel))
    (progn
    (setq as_filter (entget (car elem)))
  (if (= (cdr (assoc 0 as_filter)) "INSERT")
    (progn
      (cond
        ((or (= (cdr (assoc 66 as_filter)) 0)
             (= (assoc 66 as_filter) nil)
             ) ;_ end of or
         (alert "der Block hat keine Attribute!")
         )
        ((= (cdr (assoc 66 as_filter)) 1)
         (setq
           md_fl (ssget "X"
                        (list (cons 0 "INSERT") (assoc 2 as_filter))
                        ) ;_ end of ssget
           ) ;_ end of setq
         )
        ) ;_ end of cond
      ) ;_ end of progn
    (alert "Das war kein Block!")
    ) ;_ end of if
)
    (princ"\nNichts gewhlt - ende!"))(princ)
  md_fl
  )                                     ;ende defun



(defun md_sonst (aslst hoe brei win nei / md_txh)
  (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
  (while
    (/= (cdr (assoc 0 aslst)) "SEQEND")
     (if
       (= (cdr (assoc 0 aslst)) "ATTRIB")
        (progn
          (setq attin (assoc 11 aslst)
                attal (nth 2 attin)
                attnx (list 11 (nth 1 attin) (nth 2 attin) 0.0)
                aslst (subst attnx attin aslst)
                ) ;_ end of setq
          (if hoe
            (setq
              aslst
               (subst (cons 40 hoe) (assoc 40 aslst) aslst)
              ) ;_ end of setq
            ) ;_ end of if
          (if brei
            (setq
              aslst (subst (cons 41 brei)
                           (assoc 41 aslst)
                           aslst
                           ) ;_ end of subst
              ) ;_ end of setq
            )
            (if win
              (setq
                aslst (subst (cons 50 (angtof win 0))
                             (assoc 50 aslst)
                             aslst
                             ) ;_ end of subst
                ) ;_ end of setq
              ) ;_ end of if
            (if nei
              (setq
                aslst (subst (cons 51 (angtof nei 0))
                             (assoc 51 aslst)
                             aslst
                             ) ;_ end of subst
                ) ;_ end of setq
            ) ;_ end of if
          (entmod aslst)
          )                             ;ende progn
        )                               ;if
     (setq aslst (entget (entnext (cdr (assoc -1 aslst)))))
     )                                  ;ende while
  )                                     ;ende defun

;;;-----------------------Programmausfhrung--------------------------------------
(defun md_arbeit (md_fl     ho        br        wi     ne   /
                  md_zaehler          md_nenner info      aslst
                  md_einfwink
                  )
                                        ;(setq md_neu_atthoe (getreal "\nNeue Attrubutshhe: "))
  (setq md_zaehler 0)
  (setq md_nenner (sslength md_fl))
  (while (> md_nenner md_zaehler)
    (progn
      (setq info (ssname md_fl md_zaehler))
      (setq aslst (entget info))
      (setq md_einfwink (angtos (cdr (assoc 50 aslst)) 0 0))
      (md_sonst aslst ho br wi ne)
      )                                 ;ende progn
    (setq md_zaehler (1+ md_zaehler))
    )                                   ;ende while
  )                                     ;ende defun

;;;;;;;;;;;;;;;;;;;;;;;;;Attribute drehen / Schrifthhe gleichsetzen

(defun md_attdreh (h b w n / md_fil)


  ;;eine Objektauswahl von allen zu bearbeitenden Blcken erstellen
  (if (setq md_fil (md_filterliste))
    (md_arbeit md_fil h b w n)
    ) ;_ end of if
;;;Hauptprogrammausfhrung

  (command "regen")
  (md_reset)
;;;Variablen zurckstellen
  (setq *error* md_err)
  (princ)
  )                                     ;ende defun

;;Tauscht ein Zeichen
(defun f:str-change1 (ch_str ch_zei ch_nzei /)
  (apply 'strcat
         (mapcar '(lambda (Z)
                    (if (= Z (ascii ch_zei))
                      ch_nzei
                      (chr Z)
                      ) ;_ end of if
                    ) ;_ end of lambda
                 (mapcar 'ascii (f:str-in-list ch_str))
                 ) ;_ end of mapcar
         ) ;_ end of apply
  ) ;_ end of defun


(defun f:str-in-list (sil_str / sil_i sil_strli)
  (setq sil_i 0)
  (if (= 'STR (type sil_str))
    (reverse
      (while (< sil_i (strlen sil_str))
        (setq sil_i     (1+ sil_i)
              sil_strli (cons (substr sil_str sil_i 1) sil_strli)
              ) ;_ end of setq
        ) ;_ end of while
      ) ;_ end of reverse
    ) ;_ end of if
  ) ;_ end of defun


(prompt "\nStarten mit 'Attdreh'")
 ;|Visual LISP Format Options
(72 2 40 1 T "end of " 60 9 0 0 0 nil T nil T)
;*** KEINEN Text unterhalb des Kommentars hinzufgen! ***|;
